libstdc++: __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > Class Template Reference

libstdc++

__gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > Class Template Reference

`#include <node_iterators.hpp>`

Inheritance diagram for __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >:
[legend]

## Public Types
typedef Const_Iterator | const_reference
typedef trivial_iterator_difference_type | difference_type
typedef trivial_iterator_tag | iterator_category
typedef rebind_traits< _Alloc, metadata_type >::const_reference | metadata_const_reference
typedef Node::metadata_type | metadata_type
typedef Const_Iterator | reference
typedef Const_Iterator | value_type

## Public Member Functions
| bin_search_tree_const_node_it_ (const node_pointer p_nd=0)
bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > | get_l_child () const
metadata_const_reference | get_metadata () const
bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > | get_r_child () const
bool | operator!= (const bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > &other) const
const_reference | operator* () const
bool | operator== (const bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > &other) const

## Public Attributes
node_pointer | m_p_nd

## Detailed Description

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>
class __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >

Const node iterator.

Definition at line 58 of file bin_search_tree_/node_iterators.hpp.

## Member Typedef Documentation

## ◆ const_reference

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

typedef Const_Iterator __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::const_reference

Iterator's __const reference type.

Definition at line 77 of file bin_search_tree_/node_iterators.hpp.

## ◆ difference_type

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

typedef trivial_iterator_difference_type __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::difference_type

Difference type.

Definition at line 68 of file bin_search_tree_/node_iterators.hpp.

## ◆ iterator_category

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

typedef trivial_iterator_tag __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::iterator_category

Category.

Definition at line 65 of file bin_search_tree_/node_iterators.hpp.

## ◆ metadata_const_reference

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

typedef rebind_traits<_Alloc,metadata_type>::const_reference __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::metadata_const_reference

Const metadata reference type.

Definition at line 84 of file bin_search_tree_/node_iterators.hpp.

## ◆ metadata_type

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

typedef Node::metadata_type __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::metadata_type

Metadata type.

Definition at line 80 of file bin_search_tree_/node_iterators.hpp.

## ◆ reference

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

typedef Const_Iterator __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::reference

Iterator's reference type.

Definition at line 74 of file bin_search_tree_/node_iterators.hpp.

## ◆ value_type

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

typedef Const_Iterator __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::value_type

Iterator's value type.

Definition at line 71 of file bin_search_tree_/node_iterators.hpp.

## Constructor & Destructor Documentation

## ◆ bin_search_tree_const_node_it_()

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

__gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::bin_search_tree_const_node_it_ | ( | const node_pointer | p_nd = 0 | ) |
| inline

Definition at line 87 of file bin_search_tree_/node_iterators.hpp.

## Member Function Documentation

## ◆ get_l_child()

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::get_l_child | ( |  | ) | const
| inline

Returns the __const node iterator associated with the left node.

Definition at line 103 of file bin_search_tree_/node_iterators.hpp.

## ◆ get_metadata()

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

metadata_const_reference __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::get_metadata | ( |  | ) | const
| inline

Metadata access.

Definition at line 98 of file bin_search_tree_/node_iterators.hpp.

## ◆ get_r_child()

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::get_r_child | ( |  | ) | const
| inline

Returns the __const node iterator associated with the right node.

Definition at line 108 of file bin_search_tree_/node_iterators.hpp.

## ◆ operator!=()

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

bool __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::operator!= | ( | const bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > & | other | ) | const
| inline

Compares (negatively) to a different iterator object.

Definition at line 118 of file bin_search_tree_/node_iterators.hpp.

## ◆ operator*()

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

const_reference __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::operator* | ( |  | ) | const
| inline

Access.

Definition at line 93 of file bin_search_tree_/node_iterators.hpp.

## ◆ operator==()

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

bool __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::operator== | ( | const bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc > & | other | ) | const
| inline

Compares to a different iterator object.

Definition at line 113 of file bin_search_tree_/node_iterators.hpp.

## Member Data Documentation

## ◆ m_p_nd

template<typename Node, class Const_Iterator, class Iterator, typename _Alloc>

node_pointer __gnu_pbds::detail::bin_search_tree_const_node_it_< Node, Const_Iterator, Iterator, _Alloc >::m_p_nd

Definition at line 121 of file bin_search_tree_/node_iterators.hpp.

The documentation for this class was generated from the following file:

- bin_search_tree_/node_iterators.hpp